; MEdit 2.00 pradios failas
; Smuliau apie makro failus galite pasiskaityti MACROS.DOC

(status' MEdit.M: started.')

;
; Makrokomand apraymas
;

; Labai svarbi funkcija:
(def 'ShowBindingWindow': ; Parodyti klavi reikmes
  <New>
  <(> (ftype '.M') <ShowBindings> <TopOfFile> <)>
  )

(def 'SilentShowBindings': <(> <ShowBindings> <)>)

; Failo tipo pasirinkimas (sintaksei)
(def 'FileType':
  (menu
    'Automatic'         Enter  /* 1*/
                        Enter  /* 2*/
    '~G~eneric'         Enter  /* 3*/
    '~P~ascal'          Enter  /* 4*/
    '~C~/C++'           Enter  /* 5*/
    '~A~ssembler'       Enter  /* 6*/
    'DOS ~b~atch file'  Enter  /* 7*/
    '~D~OS CONFIG.SYS'  Enter  /* 8*/
    '~I~NI file'        Enter  /* 9*/
    '~M~Edit macro'     Enter  /*10*/
    'TvHc ~h~elp source')      /*11*/
  (case
    1: (ftype '')
    3: (ftype '-')
    4: (ftype '.PAS')
    5: (ftype '.C')
    6: (ftype '.ASM')
    7: (ftype '.BAT')
    8: (ftype 'CFGS')
    9: (ftype '.INI')
   10: (ftype '.M')
   11: (ftype '.HLS')
    )
  )

; Teksto formatavimas
(def 'Title':
  <(>
  (save block insertmode bvert)
  <CenterLine>
  <FirstChar> <MarkStart> <End> <MarkEnd>
  (if not bvert <BlockMode>)
  (if not insmode <InsertMode>) <SplitLine>
  <ToBlockStart> <Down> <OverBlock>
  <InsertMode> /* off */
  (case shift: (while inblock '=')
        true:  (while inblock '~'))
  <InsertMode> /* on */
  <NewLine> <NewLine> <Home>
  (restore all)
  <)>
  )
  ; Beje, galite paaisti itaip:
  ;   (assigndef '' '~' <*>: "*" /* ar bet koks kitas VIENAS SIMBOLIS */)
  ;   <Title>
  ;   (unassign '' '~')

(def 'Heading':
  <(>
  (save block insertmode bvert)
  <FirstChar> <MarkStart> <End> <MarkEnd>
  (if not bvert <BlockMode>)
  (if not insmode <InsertMode>) <SplitLine>
  <ToBlockStart> <Down> <OverBlock>
  <InsertMode> /* off */
  (case shift: (while inblock '=')
        true:  (while inblock '~'))
  <InsertMode> /* on */
  <NewLine> <NewLine> <Home>
  (restore all)
  <)>
  )

(def 'FrameAround': ; Nubrti rmel aplink blok
  (if not isvertblock (stop))
  <(>
  (save pos delta block)
  (if not bvert <BlockMode>)
  <ToBlockStart> Shift-(<Up> <Left>)
  <ToBlockEnd> Shift-(<Down> <Right>)
  (case shift: (Shift-<FrameBlock>)
        true:  (<FrameBlock>))
  (rest all)
  <)>
  )

(def 'Underline': ; "Pabraukti" blok/od
  (if multiline (emsg 'Cannot underline multiline block') (stop))
  <(>
  (save block pos delta insertmode)
  (if not isblock <MarkWord>)
  (if not insmode <InsertMode>)
  <ToBlockStart> <End> <Newline>
  <ToBlockStart> <Down> <OverBlock>
  <InsertMode>
  (while inblock '~')
  (rest all)
  <)>
  )

(def 'Emphasize': ; Iretinti blok/od
  (if multiline (emsg 'Cannot emphasize multiline block') (stop))
  <(>
  (save pos delta insertmode)
  (if not isblock <MarkWord>)
  (if bvert <BlockMode>)
  <ToBlockStart> <Right>
  (if not insmode <InsertMode>)
  (while InBlock ' ' <Right>)
  (rest all)
  <)>
  )

; Pagalbins
(def 'SyntaxNoCur':
  <Syntax>
  (if not syntax (stop))
  (if showcurc <ShowCol>)
  (if showcurl <ShowLine>)
  )

; DOS'o komandos
(def 'DosNavigator': ; The Best Shell in the World!
  <DosCommand>
  (while dialog
    (if state doscommand "dn" <Ok> (stop))
    (user)
    )
  )

; Gal gale meniu:
(def 'PopupMenu':
  (menu
    'Dos ~N~avigator'     Tab 'Shift-F10' Enter /*1*/
                                          Enter /*2*/
    '~S~how key bindings' Tab   'Alt-M,?' Enter /*3*/
                                          Enter /*4*/
    'File ~t~ype')                              /*5*/
  (case
    1: <DosNavigator>
    3: <ShowBindingWindow>
    5: <FileType>
    )
  )

;
; Klavi keitimas
;

(assign '' Esc          <Close>)
(assign '' F7           <Find>)
(assign '' Shift-F7     <SearchAgain>)
(assign '' Ctrl-F7      <Replace>)
(assigndef '' Alt-F7    <AltF7>:
  (case shift: <LocateNext>
        true:  <Locate>))
(assign '' Shift-F9     <DosCommand>)
(assign '' Shift-F10    <DosNavigator>)
(assign '' Alt-F10      <PopupMenu>)
(assign '' ^[           <UnindentBlock>)
(assign '' ^]           <IndentBlock>)
(assign '' Ctrl-\       <Capitalize>)

(assign '^O' X          <SyntaxNoCur>)

(assign '^Q' Ctrl-Home  <DelToStart>)
(assign '^Q' Ctrl-End   <DelToEnd>)

(assign 'Alt-R' H <Heading>)
(assign 'Alt-R' Alt-H <Heading>)
(assign 'Alt-R' T <Title>)
(assign 'Alt-R' Alt-T <Title>)

(assign 'Alt-M' K       <SilentShowBindings>)
(assign 'Alt-M' Alt-K   <SilentShowBindings>)
(assign 'Alt-M' '?'     <ShowBindingWindow>)
(primary 'Alt-M' M)

; Mano patogumui ('MEDIT.TO' redagavimui):
;  Shift-Plus  - eiti pirmyn iki eiluts, kuri prasideda ' --'
;  Shift-Minus - eiti atgal iki eiluts, kuri prasideda ' --'
;  Shift-Star  - eiti pirmyn iki eiluts, kuri prasideda ' ++'
(assigndef '' Shift-Plus <LocateForth>:
   <(><Locate>"r/^' --'"<Ok>(if found <Down>)<)>)
(assigndef '' Shift-Minus <LocateBack>:
   <(><Home><Up><Locate>"br/^' --'"<Ok>(if found <Down>)<)>)
(assigndef '' Star <Star>:
   <(>(case shift: (<Locate>"r/^' ++'"<Ok>(if found <Down>)<)>)
            true:  '*'))

(status' MEdit.M: finished.')